% GNMbode.m
% Kap. 9.8.3
% Erzeugung von Bodediagrammen von GNM_lsg_bode.mdl

% Aus der vom Block Timed-Based Linearization geschriebenen
% Struktur GNM_lsg_bode_Timed_Based_Linearization werden die
% Matrizen der Zustandsdarstellung zwecks Namensverkrzung extrahiert
% u1 = UA, u2 = MW, y1 = N
A=GNM_lsg_bode_Timed_Based_Linearization.a;
B=GNM_lsg_bode_Timed_Based_Linearization.b;
C=GNM_lsg_bode_Timed_Based_Linearization.c;
D=GNM_lsg_bode_Timed_Based_Linearization.d;

% Wurde der Block Trigger-Based Linearization verwendet,
% so lautet die Zuweisung:

%A=GNM_lsg_bode_Trigger_Based_Linearization.a;
%B=GNM_lsg_bode_Trigger_Based_Linearization.b;
%C=GNM_lsg_bode_Trigger_Based_Linearization.c;
%D=GNM_lsg_bode_Trigger_Based_Linearization.d;

% A,B,C,D knnen natrlich auch mittels
% sys_lin = linmod('GNM_lsg_bode');
% erzeugt  und mit 
% A = sys_lin.a;
% B = sys_lin.b;
% C = sys_lin.c;
% D = sys_lin.d;
% bergeben werden. 
% Dieser Befehl darf jedoch nicht in dieser Datei GNMbode.m 
% erfolgen, da
% GNMbode.m als Model Callback Funktion 'StopFcn' mit
% GNM_lsg_bode.mdl verknpft ist und diese
% bei Aufruf von linmod abgearbeitet wird (Matlab System Error)! 

% LTI-Objekt mit u1 und y1:
% (an sich kann das Bodediagramm direkt mit 
% bode(A,B(:,1),C,D(:,1)) bzw.
% bode(A,B(:,2),C,D(:,2))
% erzeugt werden;
% sollen jedoch zustzlich auch Frequenz-Grenzen, z.B. {1,10000} 
% bergeben werden funktioniert bode nur mit einem LTI-Objekt statt
% Matrizen).
sysUA_N = ss(A,B(:,1),C,D(:,1));
% LTI-Objekt mit u2 und y1:
sysMW_N = ss(A,B(:,2),C,D(:,2));

figure(1)
bode(sysUA_N,{1,10000});
grid on
figure(2)
bode(sysMW_N,{1,10000});
grid on
